from qmdl.mdl import Mdl
from qmdl.palette import palette
from PIL import Image, ImagePalette

def rename_range(frames, start, name, length):
    for i in range(length):
        frames[i + start].name = (name + str(i + 1)).encode("ascii")

def rename_frames(mdl, names):
    i = 0
    for name in names:
        rename_range(mdl.frames, i, *(name))
        i += name[1]

def append_skin(mdl, filename):
    im=Image.open(filename)
    im=im.convert("RGB")
    pim=Image.new("P", (mdl.skinwidth, mdl.skinheight))
    pim.putpalette(palette)
    pim=im.quantize(palette=pim)
    sk=Mdl.Skin(mdl.skinwidth, mdl.skinheight)
    sk.pixels=pim.tostring()
    mdl.skins.append(sk)

#read the model file
mymdl = Mdl()
with open("model.mdl", "rb") as infile:
    mymdl.read(infile)
        
#apply new sequencial names to the frames
rename_frames(mymdl, [("pose", len(mymdl.frames))])

#import these skinfiles
skinlist = []
for skin in skinlist:
    append_skin(mymdl, skin)

#write the model file
with open("model.mdl", "wb") as outfile:
    mymdl.write(outfile)
